#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <float.h>

void ajusta_linea_pca( char *nombre )
{
	FILE *arch;
	char linea[80];

	int l, i, i0, i1, n;
	double mediax, mediay;
	double x, y, a, b, c;
	double vec[2], mat[4];
	double v, vmin, vmax;
	double epsilon; 

	arch = fopen( nombre, "r" );
	if ( arch == NULL ){
		fprintf( stderr, "ERROR: No puede abrir el archivo %s\n", nombre );
		return;
	}

	n = 0;
	mediax = mediay = 0.0;
	while( fgets( linea, 80, arch ) != NULL ) {
		if ( sscanf( linea, "%lf %lf", &x, &y )  == 2 ) {
			mediax += x;
			mediay += y;
			n++;
		}
	}

	mediax /= n;
	mediay /= n;

	fseek( arch, 0, SEEK_SET );

	a = b = c = 0;
	while( fgets( linea, 80, arch ) != NULL ) {
		if ( sscanf( linea, "%lf %lf", &x, &y )  == 2 ) {
			x -= mediax;
			y -= mediay;
			a += x*x;
			b += x*y;
			c += y*y;
		}
	}
	// La matriz es ahora
	// [ a b ]
	// [ b c ]

	// Calculamos los eigenvalores
	x = a - c;
	v = x * x + 4.0 * b*b;
	v = sqrt(v);

	vmin = ((c + a) - v) / 2.0;
	vmax = ((c + a) + v) / 2.0;


	mat[0] = a - vmin;
	mat[1] = b;
	mat[2] = b;
	mat[3] = c - vmin;

	v = mat[0] * mat[0] + mat[1] * mat[1];
	epsilon = 8.0 * DBL_EPSILON * vmax;

	if (v <= epsilon) {
		vec[0] = 0.0;
		vec[1] = 1.0;
	}
	else {
		v = mat[2] * mat[2] + mat[3] * mat[3];

		if (v <= epsilon) {
			vec[0] = 1.0;
			vec[1] = 0.0;
		}
		else {
			v = sqrt(v);
			vec[0] = mat[1] / v;
			vec[1] = mat[3] / v;
		}
	}

	printf( "punto: %lf %lf\n", mediax, mediay );
	printf( "orientación: %lf %lf\n", vec[0], vec[1] );
}

int main( int argc, char *argv[] )
{
	char nombre[81];

	if( argc != 2 ) {
		fprintf( stderr, "Args: archivo_puntos\n" );
		return 1;	
	}

	strncpy( nombre, argv[1], 80 );

	ajusta_linea_pca( nombre );

	return 0;
}
